import { registerMicroApps } from 'qiankun';
import { SUB_APP_CONFIG } from '../config';

const { subApps } = SUB_APP_CONFIG;

export function registerApps() {
  try {
    registerMicroApps(subApps, {
      beforeLoad: [
        (app) => {
          console.log('before load', app);
          return Promise.resolve();
        }
      ],
      beforeMount: [
        (app) => {
          console.log('before mount', app);
          return Promise.resolve();
        }
      ],
      afterUnmount: [
        (app) => {
          console.log('before unmount', app);
          return Promise.resolve();
        }
      ]
    });

    // 拦截 popstate 事件, 解决 Oinone 路由和 主应用路由的冲突
    const originalDispatchEvent: any = window.dispatchEvent;
    window.dispatchEvent = (event: Event) => {
      if (event.type === 'popstate' && (event as PopStateEvent).state?.path) {
        console.log('Interception popStateEvent');
        return true;
      } else {
        return originalDispatchEvent.call(window, event);
      }
    };
  } catch (err) {
    console.log(err);
  }
}
