import { createApp, type App } from 'vue';
import './style.css';
import AppVue from './App.vue';
import router from './router';
import { renderWithQiankun, qiankunWindow } from 'vite-plugin-qiankun/dist/helper';

let app: App<Element> | undefined;

const render = (container?: HTMLElement) => {
  const appContainer = container?.querySelector('#son-app') ?? document.getElementById('son-app');
  if (!appContainer) {
    throw new Error('App container not found.');
  }
  app = createApp(AppVue);
  app.use(router).mount(appContainer);
};

const initQianKun = () => {
  renderWithQiankun({
    mount(props) {
      const { container } = props;
      render(container);
    },
    bootstrap() {},
    update() {},
    unmount() {
      app?.unmount();
    }
  });
};

qiankunWindow.__POWERED_BY_QIANKUN__ ? initQianKun() : render();
