import { defineConfig } from 'vite';
import vue from '@vitejs/plugin-vue';
import qiankun from 'vite-plugin-qiankun';

// https://vite.dev/config/
export default defineConfig({
  plugins: [
    vue(),
    qiankun('micro-son', {
      useDevMode: true
    })
  ],
  server: {
    cors: true,
    port: 8889,
    headers: {
      'Access-Control-Allow-Origin': '*'
    },
    proxy: {
      '/pamirs': {
        // 支持跨域
        changeOrigin: true,
        target: 'https://one.oinone.top/'
      }
    }
  }
});
